/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.management.profile.support.legacy;

import javax.management.NotCompliantMBeanException;

import org.osgi.framework.BundleContext;

import ru.entaxy.esb.platform.base.management.core.api.EntaxyRuntimeTyped;
import ru.entaxy.esb.platform.base.management.core.utils.BundleAwareMBeanImpl;
import ru.entaxy.esb.platform.core.management.profile.helper.Helpers;

// @TODO move string to constant
@EntaxyRuntimeTyped(name = "entaxy.runtime.connector")
public class LegacyConnectorMBeanImpl extends BundleAwareMBeanImpl<ManagedLegacyConnector, ConnectorMBean>
        implements ConnectorMBean {

    protected Helpers helpers;

    public LegacyConnectorMBeanImpl(BundleContext bundleContext, ManagedLegacyConnector managedObject, Helpers helpers)
            throws NotCompliantMBeanException {
        super(ConnectorMBean.class, managedObject);
        this.bundleContext = bundleContext;
        this.helpers = helpers;
    }

    @Override
    public String getFactoryId() {
        return this.managedObject.getFactoryId();
    }

    @Override
    public String getName() {
        return this.managedObject.getName();
    }

    @Override
    public String getRegisteredName() {
        return this.managedObject.getRegisteredName();
    }

    @Override
    public String getSystem() {
        return this.managedObject.getSystem();
    }

    @Override
    public String getClassifier() {
        return this.managedObject.getClassifier();
    }

    @Override
    public String getDisplayName() {
        return this.managedObject.getDisplayName();
    }

    @Override
    public String getDirection() {
        return this.managedObject.getDirection();
    }

    @Override
    public void start() throws Exception {
        this.helpers.connectorHelper.startConnector(this.managedObject.getSystem(), this.getRegisteredName());
    }

    @Override
    public void stop() throws Exception {
        this.helpers.connectorHelper.stopConnector(this.managedObject.getSystem(), this.getRegisteredName());
    }
}
